diff --git a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
new file mode 100644
index 000000000..9b14a591e
--- /dev/null
+++ b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -0,0 +1,1286 @@
+package net.minecraft.datagen;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingWithTool;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryRepairable;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryScrap;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
+import net.minecraft.datagen.recipeBuilders.RecipeBuilderShaped;
+
+import static net.minecraft.datagen.RecipesGenerator.CORE_NAMESPACE;
+
+class WorkbenchGenerator {
+    public static void generate() {
+        generatePickaxes();
+        generateAxes();
+        generateShovels();
+        generateHoes();
+        generateSwords();
+        generateMiscTools();
+
+        generateHelmets();
+        generateChestPlates();
+        generateLeggings();
+        generateBoots();
+
+        generateBlockCompression();
+        generateBlockDecompression();
+
+        generateBricks();
+        generateSlabs();
+        generateStairs();
+
+        generateDoors();
+        generateTrapDoors();
+        generateFences();
+        generateFenceGates();
+        generateChests();
+        generatePolishedStones();
+
+        generateLogToPlanks();
+        generateDyes();
+        generateDyedWools();
+        generateDyedPlanks();
+
+        generateInformationals();
+        generateRedstoneComponents();
+
+        generateFoods();
+
+        generateScrapRecipes();
+        generateRepairableRecipes();
+        generateToolRecipes();
+
+        generateUndyeingRecipes();
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "CCW",
+                    "PPP")
+                .addInput('C', Items.CLOTH)
+                .addInput('W', "minecraft:wools")
+                .addInput('P', "minecraft:planks")
+                .create("bed", Items.BED.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "###",
+                "X X")
+            .addInput('#', Items.CLOTH)
+            .addInput('X', "minecraft:planks")
+            .create("seat", Items.SEAT.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "###",
+                    "X X",
+                    "XXX")
+                .addInput('#', Items.LEATHER)
+                .addInput('X', Items.WHEAT)
+                .create("basket", Items.BASKET.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#",
+                "#",
+                "#")
+            .addInput('#', Items.PAPER)
+            .create("book_vertical", Items.BOOK.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("###")
+            .addInput('#', Items.PAPER)
+            .create("book_horizontal", Items.BOOK.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "###",
+                "XXX",
+                "###")
+            .addInput('#', "minecraft:planks")
+            .addInput('X', Items.BOOK)
+            .create("bookshelf", Blocks.BOOKSHELF_PLANKS_OAK.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X X",
+                "X#X")
+            .addInput('X', Items.INGOT_IRON)
+            .addInput('#', Blocks.COBBLE_NETHERRACK)
+            .create("brazier", Blocks.BRAZIER_INACTIVE.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "###",
+                "#X#",
+                "###")
+            .addInput('#', Items.INGOT_IRON)
+            .addInput('X', Items.NETHERCOAL)
+            .create("blast_furnace", Blocks.FURNACE_BLAST_IDLE.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "###",
+                "# #",
+                "###")
+            .addInput('#', "minecraft:cobblestones")
+            .create("furnace", Blocks.FURNACE_STONE_IDLE.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "###",
+                "#B#",
+                "#R#")
+            .addInput('#', "minecraft:cobblestones")
+            .addInput('B', Items.TOOL_BOW)
+            .addInput('R', Items.DUST_REDSTONE)
+            .create("dispenser", Blocks.DISPENSER_COBBLE_STONE.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "###",
+                "#D#",
+                "###")
+            .addInput('#', "minecraft:planks")
+            .addInput('D', Items.DIAMOND)
+            .create("jukebox", Blocks.JUKEBOX.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "XXX",
+                "XXX")
+            .addInput('X', Items.STRING)
+            .create("cobweb", Blocks.COBWEB.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X",
+                "X")
+            .addInput('X', "minecraft:planks")
+            .create("stick", new ItemStack(Items.STICK, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("###")
+            .addInput('#', Items.SUGARCANE)
+            .create("paper", new ItemStack(Items.PAPER, 6));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "XWX",
+                "XXX")
+            .addInput('X', Items.STICK)
+            .addInput('W', "minecraft:wools")
+            .create("painting", Items.PAINTING.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "X X",
+                "XXX")
+            .addInput('X', Items.INGOT_IRON)
+            .create("mesh", new ItemStack(Blocks.MESH, 8));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "X X",
+                "XXX")
+            .addInput('X', Items.INGOT_GOLD)
+            .create("mesh_gold", new ItemStack(Blocks.MESH_GOLD, 8));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "CCC",
+                "CMC",
+                "LLL")
+            .addInput('C', "minecraft:cobblestones")
+            .addInput('M', Blocks.MESH)
+            .addInput('L', "minecraft:logs")
+            .create("trommel", Blocks.TROMMEL_IDLE.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X X",
+                "XXX",
+                "X X")
+            .addInput('X', Items.STICK)
+            .create("ladder", new ItemStack(Blocks.LADDER_OAK, 2));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "XXX",
+                " # ")
+            .addInput('X', "minecraft:planks")
+            .addInput('#', Items.STICK)
+            .create("sign", new ItemStack(Items.SIGN, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "# #",
+                " # ")
+            .addInput('#', Blocks.GLASS)
+            .create("jar", new ItemStack(Items.JAR, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#XX",
+                "#XX",
+                "#  ")
+            .addInput('#', Items.STICK)
+            .addInput('X', Items.CLOTH)
+            .create("flag", Items.FLAG.getDefaultStack());
+
+        RecipeBuilderShaped shape22 = new RecipeBuilderShaped(CORE_NAMESPACE)
+            .setShape(
+                "##",
+                "##");
+
+        shape22.addInput('#', Items.DUST_GLOWSTONE).create("glowstone", Blocks.GLOWSTONE.getDefaultStack());
+        shape22.addInput('#', Items.CLAY).create("clay_block", Blocks.BLOCK_CLAY.getDefaultStack());
+        shape22.addInput('#', Items.AMMO_SNOWBALL).create("snow_block", Blocks.BLOCK_SNOW.getDefaultStack());
+        shape22.addInput('#', Items.STRING).create("string_to_wool", Blocks.WOOL.getDefaultStack());
+        shape22.addInput('#', Items.AMMO_PEBBLE).create("pebbles_to_cobblestone", Blocks.COBBLE_STONE.getDefaultStack());
+        shape22.addInput('#', Blocks.SAND).create("sandstone", new ItemStack(Blocks.SANDSTONE, 2));
+        shape22.addInput('#', "minecraft:planks").create("workbench", Blocks.WORKBENCH.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X",
+                "X#")
+            .addInput('#', Items.AMMO_PEBBLE)
+            .addInput('X', Items.COAL)
+            .create("pebbles_to_basalt", new ItemStack(Blocks.COBBLE_BASALT, 2));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X",
+                "X#")
+            .addInput('#', Items.AMMO_PEBBLE)
+            .addInput('X', Items.QUARTZ)
+            .create("pebbles_to_granite", new ItemStack(Blocks.COBBLE_GRANITE, 2));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X",
+                "X#")
+            .addInput('#', Items.AMMO_PEBBLE)
+            .addInput('X', Blocks.SAND)
+            .create("pebbles_to_limestone", new ItemStack(Blocks.COBBLE_LIMESTONE, 2));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X",
+                "X#")
+            .addInput('#', Blocks.PERMAFROST)
+            .addInput('X', Blocks.ICE)
+            .create("perma_ice", new ItemStack(Blocks.PERMAICE, 2));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "FPF",
+                "PFP",
+                "FPF")
+            .addInput('F', Items.FLINT)
+            .addInput('P', Items.AMMO_PEBBLE)
+            .create("gravel_from_flint_and_pebbles", Blocks.GRAVEL.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#",
+                "#")
+            .addInput('#', Items.STRING)
+            .create("rope", new ItemStack(Items.ROPE, 2));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X",
+                "X#")
+            .addInput('#', Blocks.GLASS)
+            .addInput('X', Items.INGOT_STEEL)
+            .create("steel_glass", new ItemStack(Blocks.GLASS_STEEL, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X",
+                "X#")
+            .addInput('#', Blocks.GLASS)
+            .addInput('X', Items.OLIVINE)
+            .create("tinted_glass", new ItemStack(Blocks.GLASS_TINTED, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X",
+                "X#")
+            .addInput('#', Items.PAPER)
+            .addInput('X', "minecraft:planks")
+            .create("paper_wall", new ItemStack(Blocks.PAPER_WALL, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X",
+                "#")
+            .addInput('#', Items.STICK)
+            .addInput('X', Items.COAL)
+            .create("torch_coal", new ItemStack(Blocks.TORCH_COAL, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X",
+                "#")
+            .addInput('#', Items.STICK)
+            .addInput('X', Items.COAL, 1)
+            .create("torch_charcoal", new ItemStack(Blocks.TORCH_COAL, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X",
+                "#")
+            .addInput('#', Items.STICK)
+            .addInput('X', Items.NETHERCOAL)
+            .create("torch_nethercoal", new ItemStack(Blocks.TORCH_COAL, 8));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X",
+                "#")
+            .addInput('X', Blocks.PUMPKIN_CARVED_IDLE)
+            .addInput('#', Blocks.TORCH_COAL)
+            .create("carved_pumpkin_to_jack_o_lantern", Blocks.PUMPKIN_CARVED_ACTIVE.getDefaultStack());
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Blocks.SPONGE_DRY)
+            .addInput(Items.BUCKET_WATER)
+            .create("sponge_to_wet_sponge", Blocks.SPONGE_WET.getDefaultStack());
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Blocks.PUMPKIN)
+            .create("pumpkin_to_pumpkin_seeds", new ItemStack(Items.SEEDS_PUMPKIN, 4));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Blocks.SLATE)
+            .create("slate_to_slate_layers", new ItemStack(Blocks.LAYER_SLATE, 8));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Blocks.LEAVES_OAK)
+            .create("oak_leaves_to_leaf_pile", new ItemStack(Blocks.LAYER_LEAVES_OAK, 8));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "##")
+            .addInput('#', Items.AMMO_SNOWBALL)
+            .create("snowballs_to_snow_layer", new ItemStack(Blocks.LAYER_SNOW, 2));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X",
+                "Y",
+                "Z")
+            .addInput('X', Items.FEATHER_CHICKEN)
+            .addInput('Y', Items.INGOT_IRON)
+            .addInput('Z', Items.STICK)
+            .create("paintbrush", new ItemStack(Items.PAINTBRUSH, 1, Items.PAINTBRUSH.getMaxDamage())); // Create brush with 0 durability
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "###")
+            .addInput('#', Items.INGOT_STEEL_CRUDE)
+            .create("crude_steel_to_steel_ingot", Items.INGOT_STEEL.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#",
+                "#")
+            .addInput('#', Blocks.MARBLE)
+            .create("marble_pillar", new ItemStack(Blocks.PILLAR_MARBLE, 2));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "PI",
+                "S ")
+            .addInput('P', Items.PAPER)
+            .addInput('I', new ItemStack(Items.DYE, 1, DyeColor.BLACK.itemMeta))
+            .addInput('S', Items.STRING)
+            .create("blank_label", Items.LABEL.getDefaultStack());
+    }
+    private static void generatePickaxes() {
+        RecipeBuilderShaped pickaxeTemplate = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                " # ",
+                " # ")
+            .addInput('#', Items.STICK);
+
+        pickaxeTemplate.addInput('X', "minecraft:planks").create("wooden_pickaxe", Items.TOOL_PICKAXE_WOOD.getDefaultStack());
+        pickaxeTemplate.addInput('X', "minecraft:cobblestones").create("stone_pickaxe", Items.TOOL_PICKAXE_STONE.getDefaultStack());
+        pickaxeTemplate.addInput('X', Items.INGOT_IRON).create("iron_pickaxe", Items.TOOL_PICKAXE_IRON.getDefaultStack());
+        pickaxeTemplate.addInput('X', Items.INGOT_GOLD).create("golden_pickaxe", Items.TOOL_PICKAXE_GOLD.getDefaultStack());
+        pickaxeTemplate.addInput('X', Items.DIAMOND).create("diamond_pickaxe", Items.TOOL_PICKAXE_DIAMOND.getDefaultStack());
+        pickaxeTemplate.addInput('X', Items.INGOT_STEEL).create("steel_pickaxe", Items.TOOL_PICKAXE_STEEL.getDefaultStack());
+    }
+
+    private static void generateAxes() {
+        RecipeBuilderShaped axeTemplate = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XX",
+                "X#",
+                " #")
+            .addInput('#', Items.STICK);
+
+        axeTemplate.addInput('X', "minecraft:planks").create("wooden_axe", Items.TOOL_AXE_WOOD.getDefaultStack());
+        axeTemplate.addInput('X', "minecraft:cobblestones").create("stone_axe", Items.TOOL_AXE_STONE.getDefaultStack());
+        axeTemplate.addInput('X', Items.INGOT_IRON).create("iron_axe", Items.TOOL_AXE_IRON.getDefaultStack());
+        axeTemplate.addInput('X', Items.INGOT_GOLD).create("golden_axe", Items.TOOL_AXE_GOLD.getDefaultStack());
+        axeTemplate.addInput('X', Items.DIAMOND).create("diamond_axe", Items.TOOL_AXE_DIAMOND.getDefaultStack());
+        axeTemplate.addInput('X', Items.INGOT_STEEL).create("steel_axe", Items.TOOL_AXE_STEEL.getDefaultStack());
+    }
+
+    private static void generateShovels() {
+        RecipeBuilderShaped shovelTemplate = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X",
+                "#",
+                "#")
+            .addInput('#', Items.STICK);
+
+        shovelTemplate.addInput('X', "minecraft:planks").create("wooden_shovel", Items.TOOL_SHOVEL_WOOD.getDefaultStack());
+        shovelTemplate.addInput('X', "minecraft:cobblestones").create("stone_shovel", Items.TOOL_SHOVEL_STONE.getDefaultStack());
+        shovelTemplate.addInput('X', Items.INGOT_IRON).create("iron_shovel", Items.TOOL_SHOVEL_IRON.getDefaultStack());
+        shovelTemplate.addInput('X', Items.INGOT_GOLD).create("golden_shovel", Items.TOOL_SHOVEL_GOLD.getDefaultStack());
+        shovelTemplate.addInput('X', Items.DIAMOND).create("diamond_shovel", Items.TOOL_SHOVEL_DIAMOND.getDefaultStack());
+        shovelTemplate.addInput('X', Items.INGOT_STEEL).create("steel_shovel", Items.TOOL_SHOVEL_STEEL.getDefaultStack());
+    }
+
+    private static void generateHoes() {
+        RecipeBuilderShaped hoeTemplate = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XX",
+                " #",
+                " #")
+            .addInput('#', Items.STICK);
+
+        hoeTemplate.addInput('X', "minecraft:planks").create("wooden_hoe", Items.TOOL_HOE_WOOD.getDefaultStack());
+        hoeTemplate.addInput('X', "minecraft:cobblestones").create("stone_hoe", Items.TOOL_HOE_STONE.getDefaultStack());
+        hoeTemplate.addInput('X', Items.INGOT_IRON).create("iron_hoe", Items.TOOL_HOE_IRON.getDefaultStack());
+        hoeTemplate.addInput('X', Items.INGOT_GOLD).create("golden_hoe", Items.TOOL_HOE_GOLD.getDefaultStack());
+        hoeTemplate.addInput('X', Items.DIAMOND).create("diamond_hoe", Items.TOOL_HOE_DIAMOND.getDefaultStack());
+        hoeTemplate.addInput('X', Items.INGOT_STEEL).create("steel_hoe", Items.TOOL_HOE_STEEL.getDefaultStack());
+    }
+
+    private static void generateSwords() {
+        RecipeBuilderShaped sword = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X",
+                "X",
+                "#")
+            .addInput('#', Items.STICK);
+
+        sword.addInput('X', "minecraft:planks").create("wooden_sword", Items.TOOL_SWORD_WOOD.getDefaultStack());
+        sword.addInput('X', "minecraft:cobblestones").create("stone_sword", Items.TOOL_SWORD_STONE.getDefaultStack());
+        sword.addInput('X', Items.INGOT_IRON).create("iron_sword", Items.TOOL_SWORD_IRON.getDefaultStack());
+        sword.addInput('X', Items.INGOT_GOLD).create("golden_sword", Items.TOOL_SWORD_GOLD.getDefaultStack());
+        sword.addInput('X', Items.DIAMOND).create("diamond_sword", Items.TOOL_SWORD_DIAMOND.getDefaultStack());
+        sword.addInput('X', Items.INGOT_STEEL).create("steel_sword", Items.TOOL_SWORD_STEEL.getDefaultStack());
+    }
+
+    private static void generateMiscTools() {
+        RecipeBuilderShaped shears = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                " X",
+                "X ");
+
+        shears.addInput('X', Items.INGOT_IRON).create("shears", Items.TOOL_SHEARS.getDefaultStack());
+        shears.addInput('X', Items.INGOT_STEEL).create("steel_shears", Items.TOOL_SHEARS_STEEL.getDefaultStack());
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.INGOT_IRON).addInput(Items.FLINT).create("fire_striker", Items.TOOL_FIRESTRIKER_IRON.getDefaultStack());
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.INGOT_STEEL).addInput(Items.FLINT).create("steel_fire_striker", Items.TOOL_FIRESTRIKER_STEEL.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "# #",
+                " # ")
+            .addInput('#', Items.INGOT_IRON)
+            .create("bucket", Items.BUCKET.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "# #",
+                "###")
+            .addInput('#', "minecraft:planks")
+            .create("boat", Items.BOAT.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "# #",
+                "###")
+            .addInput('#', Items.INGOT_IRON)
+            .create("minecart", Items.MINECART.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "A",
+                "B")
+            .addInput('A', "minecraft:chests")
+            .addInput('B', Items.MINECART)
+            .create("minecart_with_chest", Items.MINECART_CHEST.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "A",
+                "B")
+            .addInput('A', Blocks.FURNACE_STONE_IDLE)
+            .addInput('B', Items.MINECART)
+            .create("minecart_with_furnace", Items.MINECART_FURNACE.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                " #X",
+                "# X",
+                " #X")
+            .addInput('#', Items.STICK)
+            .addInput('X', Items.STRING)
+            .create("bow", Items.TOOL_BOW.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#OO",
+                "#XX",
+                " XX")
+            .addInput('#', Items.STRING)
+            .addInput('X', Items.LEATHER)
+            .addInput('O', Items.CLOTH)
+            .create("quiver", Items.ARMOR_QUIVER.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "T",
+                "I",
+                "V")
+            .addInput('T', Items.FLINT)
+            .addInput('I', Items.STICK)
+            .addInput('V', Items.FEATHER_CHICKEN)
+            .create("arrow", new ItemStack(Items.AMMO_ARROW, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                " X ",
+                "X#X",
+                " X ")
+            .addInput('X', Items.AMMO_ARROW)
+            .addInput('#', Items.INGOT_GOLD)
+            .create("golden_arrow", new ItemStack(Items.AMMO_ARROW_GOLD, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "  #",
+                " #S",
+                "# S")
+            .addInput('#', Items.STICK)
+            .addInput('S', Items.STRING)
+            .create("fishing_rod", Items.TOOL_FISHINGROD.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X  ",
+                "#X ",
+                " #O")
+            .addInput('X', "minecraft:logs")
+            .addInput('#', Items.INGOT_STEEL)
+            .addInput('O', Items.TOOL_BOW)
+            .create("hand_cannon", Items.HANDCANNON_UNLOADED.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                " S ",
+                "#X#",
+                " # ")
+            .addInput('S', Items.STRING)
+            .addInput('#', Items.INGOT_IRON)
+            .addInput('X', Items.SULPHUR)
+            .create("explosive_charge", new ItemStack(Items.AMMO_CHARGE_EXPLOSIVE, 4));
+    }
+
+    private static void generateHelmets() {
+        RecipeBuilderShaped helmet = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "X X"
+            );
+
+        helmet.addInput('X', Items.LEATHER).create("leather_helmet", Items.ARMOR_HELMET_LEATHER.getDefaultStack());
+        helmet.addInput('X', Items.INGOT_IRON).create("iron_helmet", Items.ARMOR_HELMET_IRON.getDefaultStack());
+        helmet.addInput('X', Items.INGOT_GOLD).create("golden_helmet", Items.ARMOR_HELMET_GOLD.getDefaultStack());
+        helmet.addInput('X', Items.DIAMOND).create("diamond_helmet", Items.ARMOR_HELMET_DIAMOND.getDefaultStack());
+        helmet.addInput('X', Items.INGOT_STEEL).create("steel_helmet", Items.ARMOR_HELMET_STEEL.getDefaultStack());
+    }
+
+    private static void generateChestPlates() {
+        RecipeBuilderShaped chestplate = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X X",
+                "XXX",
+                "XXX"
+            );
+
+        chestplate.addInput('X', Items.LEATHER).create("leather_chestplate", Items.ARMOR_CHESTPLATE_LEATHER.getDefaultStack());
+        chestplate.addInput('X', Items.INGOT_IRON).create("iron_chestplate", Items.ARMOR_CHESTPLATE_IRON.getDefaultStack());
+        chestplate.addInput('X', Items.INGOT_GOLD).create("golden_chestplate", Items.ARMOR_CHESTPLATE_GOLD.getDefaultStack());
+        chestplate.addInput('X', Items.DIAMOND).create("diamond_chestplate", Items.ARMOR_CHESTPLATE_DIAMOND.getDefaultStack());
+        chestplate.addInput('X', Items.INGOT_STEEL).create("steel_chestplate", Items.ARMOR_CHESTPLATE_STEEL.getDefaultStack());
+    }
+
+    private static void generateLeggings() {
+        RecipeBuilderShaped leggings = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "X X",
+                "X X"
+            );
+
+        leggings.addInput('X', Items.LEATHER).create("leather_leggings", Items.ARMOR_LEGGINGS_LEATHER.getDefaultStack());
+        leggings.addInput('X', Items.INGOT_IRON).create("iron_leggings", Items.ARMOR_LEGGINGS_IRON.getDefaultStack());
+        leggings.addInput('X', Items.INGOT_GOLD).create("golden_leggings", Items.ARMOR_LEGGINGS_GOLD.getDefaultStack());
+        leggings.addInput('X', Items.DIAMOND).create("diamond_leggings", Items.ARMOR_LEGGINGS_DIAMOND.getDefaultStack());
+        leggings.addInput('X', Items.INGOT_STEEL).create("steel_leggings", Items.ARMOR_LEGGINGS_STEEL.getDefaultStack());
+    }
+
+    private static void generateBoots() {
+        RecipeBuilderShaped boots = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X X",
+                "X X"
+            );
+
+        boots.addInput('X', Items.LEATHER).create("leather_boots", Items.ARMOR_BOOTS_LEATHER.getDefaultStack());
+        boots.addInput('X', Items.INGOT_IRON).create("iron_boots", Items.ARMOR_BOOTS_IRON.getDefaultStack());
+        boots.addInput('X', Items.INGOT_GOLD).create("golden_boots", Items.ARMOR_BOOTS_GOLD.getDefaultStack());
+        boots.addInput('X', Items.DIAMOND).create("diamond_boots", Items.ARMOR_BOOTS_DIAMOND.getDefaultStack());
+        boots.addInput('X', Items.INGOT_STEEL).create("steel_boots", Items.ARMOR_BOOTS_STEEL.getDefaultStack());
+    }
+
+    private static void generateBlockCompression() {
+        RecipeBuilderShaped block = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "XXX",
+                "XXX"
+            );
+
+        RecipeBuilderShaped blockFuel = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "X X",
+                "XXX"
+            );
+
+        block.addInput('X', Items.INGOT_GOLD).create("block_of_gold", Blocks.BLOCK_GOLD.getDefaultStack());
+        block.addInput('X', Items.INGOT_IRON).create("block_of_iron", Blocks.BLOCK_IRON.getDefaultStack());
+        block.addInput('X', Items.INGOT_STEEL).create("block_of_steel", Blocks.BLOCK_STEEL.getDefaultStack());
+        block.addInput('X', Items.DYE, DyeColor.BLUE.itemMeta).create("block_of_lapis_lazuli", Blocks.BLOCK_LAPIS.getDefaultStack());
+        block.addInput('X', Items.DUST_REDSTONE).create("block_of_redstone", Blocks.BLOCK_REDSTONE.getDefaultStack());
+        block.addInput('X', Items.DIAMOND).create("block_of_diamond", Blocks.BLOCK_DIAMOND.getDefaultStack());
+        block.addInput('X', Items.QUARTZ).create("block_of_quartz", Blocks.BLOCK_QUARTZ.getDefaultStack());
+        block.addInput('X', Items.SUGARCANE).create("block_of_sugarcane", Blocks.BLOCK_SUGARCANE.getDefaultStack());
+
+        blockFuel.addInput('X', Items.COAL, 0).create("block_of_coal", Blocks.BLOCK_COAL.getDefaultStack());
+        blockFuel.addInput('X', Items.COAL, 1).create("block_of_charcoal", Blocks.BLOCK_CHARCOAL.getDefaultStack());
+        blockFuel.addInput('X', Items.NETHERCOAL).create("block_of_nethercoal", Blocks.BLOCK_NETHER_COAL.getDefaultStack());
+        blockFuel.addInput('X', Items.OLIVINE).create("block_of_olivine", Blocks.BLOCK_OLIVINE.getDefaultStack());
+    }
+
+    private static void generateBlockDecompression() {
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_GOLD).create("block_of_gold_to_gold_ingot", new ItemStack(Items.INGOT_GOLD, 9));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_IRON).create("block_of_iron_to_iron_ingot", new ItemStack(Items.INGOT_IRON, 9));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_STEEL).create("block_of_steel_to_steel_ingot", new ItemStack(Items.INGOT_STEEL, 9));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_LAPIS).create("block_of_lapis_lazuli_to_lapis_lazuli", new ItemStack(Items.DYE, 9, DyeColor.BLUE.itemMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_REDSTONE).create("block_of_redstone_to_redstone", new ItemStack(Items.DUST_REDSTONE, 9));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_DIAMOND).create("block_of_diamond_to_diamond", new ItemStack(Items.DIAMOND, 9));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_QUARTZ).create("block_of_quartz_to_quartz", new ItemStack(Items.QUARTZ, 9));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_COAL).create("block_of_coal_to_coal", new ItemStack(Items.COAL, 8, 0));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_CHARCOAL).create("block_of_charcoal_to_charcoal", new ItemStack(Items.COAL, 8, 1));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_NETHER_COAL).create("block_of_nethercoal_to_nethercoal", new ItemStack(Items.NETHERCOAL, 8));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.BLOCK_OLIVINE).create("block_of_olivine_to_olivine", new ItemStack(Items.OLIVINE, 8));
+    }
+
+    private static void generateBricks() {
+        RecipeBuilderShaped bricks = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XX",
+                "XX"
+            );
+
+        final int stackSize = 4;
+
+        bricks.addInput('X', Items.BRICK_CLAY).create("clay_bricks", new ItemStack(Blocks.BRICK_CLAY, stackSize));
+        bricks.addInput('X', Items.INGOT_GOLD).create("golden_bricks", new ItemStack(Blocks.BRICK_GOLD, stackSize));
+        bricks.addInput('X', Items.INGOT_IRON).create("iron_bricks", new ItemStack(Blocks.BRICK_IRON, stackSize));
+        bricks.addInput('X', Items.DYE, DyeColor.BLUE.itemMeta).create("lapis_lazuli_bricks", new ItemStack(Blocks.BRICK_LAPIS, stackSize));
+        bricks.addInput('X', Blocks.SANDSTONE).create("sandstone_bricks", new ItemStack(Blocks.BRICK_SANDSTONE, stackSize));
+        bricks.addInput('X', Blocks.STONE).create("stone_bricks", new ItemStack(Blocks.BRICK_STONE, stackSize));
+        bricks.addInput('X', Blocks.BASALT).create("basalt_bricks", new ItemStack(Blocks.BRICK_BASALT, stackSize));
+        bricks.addInput('X', Blocks.GRANITE).create("granite_bricks", new ItemStack(Blocks.BRICK_GRANITE, stackSize));
+        bricks.addInput('X', Blocks.LIMESTONE).create("limestone_bricks", new ItemStack(Blocks.BRICK_LIMESTONE, stackSize));
+        bricks.addInput('X', Blocks.MARBLE).create("marble_bricks", new ItemStack(Blocks.BRICK_MARBLE, stackSize));
+        bricks.addInput('X', Blocks.SLATE).create("slate_bricks", new ItemStack(Blocks.BRICK_SLATE, stackSize));
+        bricks.addInput('X', Blocks.PERMAFROST).create("permafrost_bricks", new ItemStack(Blocks.BRICK_PERMAFROST, stackSize));
+        bricks.addInput('X', Blocks.NETHERRACK).create("netherrack_bricks", new ItemStack(Blocks.BRICK_NETHERRACK, stackSize));
+        bricks.addInput('X', Blocks.STONE_POLISHED).create("polished_stone_bricks", new ItemStack(Blocks.BRICK_STONE_POLISHED, stackSize));
+    }
+
+    private static void generateSlabs() {
+        RecipeBuilderShaped slabs = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX"
+            );
+
+        final int stackSize = 6;
+
+        for (DyeColor color : DyeColor.values()) {
+            slabs.addInput('X', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_wooden_slab", new ItemStack(Blocks.SLAB_PLANKS_PAINTED, stackSize, color.blockMeta << 4));
+        }
+        slabs.addInput('X', Blocks.PLANKS_OAK).create("wooden_slab", new ItemStack(Blocks.SLAB_PLANKS_OAK, stackSize));
+        slabs.addInput('X', Blocks.SANDSTONE).create("sandstone_slab", new ItemStack(Blocks.SLAB_SANDSTONE, stackSize));
+
+        slabs.addInput('X', Blocks.COBBLE_STONE).create("cobbled_stone_slab", new ItemStack(Blocks.SLAB_COBBLE_STONE, stackSize));
+        slabs.addInput('X', Blocks.COBBLE_BASALT).create("cobbled_basalt_slab", new ItemStack(Blocks.SLAB_COBBLE_BASALT, stackSize));
+        slabs.addInput('X', Blocks.COBBLE_GRANITE).create("cobbled_granite_slab", new ItemStack(Blocks.SLAB_COBBLE_GRANITE, stackSize));
+        slabs.addInput('X', Blocks.COBBLE_LIMESTONE).create("cobbled_limestone_slab", new ItemStack(Blocks.SLAB_COBBLE_LIMESTONE, stackSize));
+        slabs.addInput('X', Blocks.COBBLE_PERMAFROST).create("cobbled_permafrost_slab", new ItemStack(Blocks.SLAB_COBBLE_PERMAFROST, stackSize));
+        slabs.addInput('X', Blocks.COBBLE_NETHERRACK).create("cobbled_netherrack_slab", new ItemStack(Blocks.SLAB_COBBLE_NETHERRACK, stackSize));
+
+        slabs.addInput('X', Blocks.MARBLE).create("marble_slab", new ItemStack(Blocks.SLAB_CAPSTONE_MARBLE, stackSize));
+        slabs.addInput('X', Blocks.STONE_POLISHED).create("polished_stone_slab", new ItemStack(Blocks.SLAB_STONE_POLISHED, stackSize));
+        slabs.addInput('X', Blocks.BRICK_STONE_POLISHED).create("polished_stone_brick_slab", new ItemStack(Blocks.SLAB_BRICK_STONE_POLISHED, stackSize));
+        slabs.addInput('X', Blocks.BASALT_POLISHED).create("polished_basalt_slab", new ItemStack(Blocks.SLAB_BASALT_POLISHED, stackSize));
+        slabs.addInput('X', Blocks.GRANITE_POLISHED).create("polished_granite_slab", new ItemStack(Blocks.SLAB_GRANITE_POLISHED, stackSize));
+        slabs.addInput('X', Blocks.LIMESTONE_POLISHED).create("polished_limestone_slab", new ItemStack(Blocks.SLAB_LIMESTONE_POLISHED, stackSize));
+        slabs.addInput('X', Blocks.PERMAFROST_POLISHED).create("polished_permafrost_slab", new ItemStack(Blocks.SLAB_PERMAFROST_POLISHED, stackSize));
+        slabs.addInput('X', Blocks.NETHERRACK_POLISHED).create("polished_netherrack_slab", new ItemStack(Blocks.SLAB_NETHERRACK_POLISHED, stackSize));
+
+        slabs.addInput('X', Blocks.BRICK_MARBLE).create("marble_brick_slab", new ItemStack(Blocks.SLAB_BRICK_MARBLE, stackSize));
+        slabs.addInput('X', Blocks.BRICK_STONE).create("stone_brick_slab", new ItemStack(Blocks.SLAB_BRICK_STONE, stackSize));
+        slabs.addInput('X', Blocks.BRICK_BASALT).create("basalt_brick_slab", new ItemStack(Blocks.SLAB_BRICK_BASALT, stackSize));
+        slabs.addInput('X', Blocks.BRICK_GRANITE).create("granite_brick_slab", new ItemStack(Blocks.SLAB_BRICK_GRANITE, stackSize));
+        slabs.addInput('X', Blocks.BRICK_LIMESTONE).create("limestone_brick_slab", new ItemStack(Blocks.SLAB_BRICK_LIMESTONE, stackSize));
+        slabs.addInput('X', Blocks.BRICK_SLATE).create("slate_brick_slab", new ItemStack(Blocks.SLAB_BRICK_SLATE, stackSize));
+        slabs.addInput('X', Blocks.BRICK_CLAY).create("clay_brick_slab", new ItemStack(Blocks.SLAB_BRICK_CLAY, stackSize));
+        slabs.addInput('X', Blocks.BRICK_SANDSTONE).create("brick_sandstone_slab", new ItemStack(Blocks.SLAB_BRICK_SANDSTONE, stackSize));
+        slabs.addInput('X', Blocks.BRICK_PERMAFROST).create("brick_permafrost_slab", new ItemStack(Blocks.SLAB_BRICK_PERMAFROST, stackSize));
+        slabs.addInput('X', Blocks.BRICK_NETHERRACK).create("netherrack_brick_slab", new ItemStack(Blocks.SLAB_BRICK_NETHERRACK, stackSize));
+    }
+
+    private static void generateStairs() {
+        RecipeBuilderShaped stairs = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X  ",
+                "XX ",
+                "XXX"
+            );
+
+        final int stackSize = 6;
+
+        for (DyeColor color : DyeColor.values()) {
+            stairs
+                .addInput('X', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_wooden_stairs", new ItemStack(Blocks.STAIRS_PLANKS_PAINTED, stackSize, color.blockMeta << 4));
+        }
+
+        stairs.addInput('X', Blocks.PLANKS_OAK).create("wooden_stairs", new ItemStack(Blocks.STAIRS_PLANKS_OAK, stackSize));
+        stairs.addInput('X', Blocks.SANDSTONE).create("sandstone_stairs", new ItemStack(Blocks.STAIRS_SANDSTONE, stackSize));
+
+        stairs.addInput('X', Blocks.COBBLE_STONE).create("cobblestone_stairs", new ItemStack(Blocks.STAIRS_COBBLE_STONE, stackSize));
+        stairs.addInput('X', Blocks.COBBLE_BASALT).create("cobbled_basalt_stairs", new ItemStack(Blocks.STAIRS_COBBLE_BASALT, stackSize));
+        stairs.addInput('X', Blocks.COBBLE_GRANITE).create("cobbled_granite_stairs", new ItemStack(Blocks.STAIRS_COBBLE_GRANITE, stackSize));
+        stairs.addInput('X', Blocks.COBBLE_LIMESTONE).create("cobbled_limestone_stairs", new ItemStack(Blocks.STAIRS_COBBLE_LIMESTONE, stackSize));
+        stairs.addInput('X', Blocks.COBBLE_PERMAFROST).create("cobbled_permafrost_stairs", new ItemStack(Blocks.STAIRS_COBBLE_PERMAFROST, stackSize));
+        stairs.addInput('X', Blocks.COBBLE_NETHERRACK).create("cobbled_netherrack_stairs", new ItemStack(Blocks.STAIRS_COBBLE_NETHERRACK, stackSize));
+
+        stairs.addInput('X', Blocks.BRICK_STONE_POLISHED).create("polished_stone_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_STONE_POLISHED, stackSize));
+
+        stairs.addInput('X', Blocks.BRICK_MARBLE).create("marble_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_MARBLE, stackSize));
+        stairs.addInput('X', Blocks.BRICK_STONE).create("stone_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_STONE, stackSize));
+        stairs.addInput('X', Blocks.BRICK_BASALT).create("basalt_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_BASALT, stackSize));
+        stairs.addInput('X', Blocks.BRICK_GRANITE).create("granite_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_GRANITE, stackSize));
+        stairs.addInput('X', Blocks.BRICK_LIMESTONE).create("limestone_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_LIMESTONE, stackSize));
+        stairs.addInput('X', Blocks.BRICK_SLATE).create("slate_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_SLATE, stackSize));
+        stairs.addInput('X', Blocks.BRICK_CLAY).create("clay_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_CLAY, stackSize));
+        stairs.addInput('X', Blocks.BRICK_SANDSTONE).create("brick_sandstone_stairs", new ItemStack(Blocks.STAIRS_BRICK_SANDSTONE, stackSize));
+        stairs.addInput('X', Blocks.BRICK_PERMAFROST).create("brick_permafrost_stairs", new ItemStack(Blocks.STAIRS_BRICK_PERMAFROST, stackSize));
+        stairs.addInput('X', Blocks.BRICK_NETHERRACK).create("netherrack_brick_stairs", new ItemStack(Blocks.STAIRS_BRICK_NETHERRACK, stackSize));
+    }
+
+    private static void generateDoors() {
+        RecipeBuilderShaped door = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XX",
+                "XX",
+                "XX"
+            );
+        final int stackSize = 2;
+
+        for (DyeColor color : DyeColor.values()) {
+            door.addInput('X', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_wooden_door", new ItemStack(Items.DOOR_OAK_PAINTED, stackSize, color.itemMeta));
+        }
+        door.addInput('X', Blocks.PLANKS_OAK).create("wooden_door", new ItemStack(Items.DOOR_OAK, stackSize));
+        door.addInput('X', Blocks.GLASS).create("glass_door", new ItemStack(Items.DOOR_GLASS, stackSize));
+        door.addInput('X', Items.INGOT_IRON).create("iron_door", new ItemStack(Items.DOOR_IRON, stackSize));
+        door.addInput('X', Items.INGOT_STEEL).create("steel_door", new ItemStack(Items.DOOR_STEEL, stackSize));
+    }
+
+    private static void generateTrapDoors() {
+        RecipeBuilderShaped door = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "XXX"
+            );
+        final int stackSize = 6;
+
+        for (DyeColor color : DyeColor.values()) {
+            door.addInput('X', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_wooden_trapdoor", new ItemStack(Blocks.TRAPDOOR_PLANKS_PAINTED, stackSize, color.blockMeta << 4));
+        }
+        door.addInput('X', Blocks.PLANKS_OAK).create("wooden_trapdoor", new ItemStack(Blocks.TRAPDOOR_PLANKS_OAK, stackSize));
+        door.addInput('X', Blocks.GLASS).create("glass_trapdoor", new ItemStack(Blocks.TRAPDOOR_GLASS, stackSize));
+        door.addInput('X', Items.INGOT_IRON).create("iron_trapdoor", new ItemStack(Blocks.TRAPDOOR_IRON, stackSize));
+        door.addInput('X', Items.INGOT_STEEL).create("steel_trapdoor", new ItemStack(Blocks.TRAPDOOR_STEEL, stackSize));
+    }
+
+    private static void generateFences() {
+        RecipeBuilderShaped fence = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X#X",
+                "X#X"
+            );
+
+        RecipeBuilderShaped woodenFence = fence.addInput('#', Items.STICK);
+
+        final int stackSize = 6;
+
+        for (DyeColor color : DyeColor.values()) {
+            woodenFence.addInput('X', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_wooden_fence", new ItemStack(Blocks.FENCE_PLANKS_OAK_PAINTED, stackSize, color.blockMeta));
+        }
+        woodenFence.addInput('X', Blocks.PLANKS_OAK).create("wooden_fence", new ItemStack(Blocks.FENCE_PLANKS_OAK, stackSize));
+
+        fence.addInput('X', Items.STICK).addInput('#', Blocks.PAPER_WALL).create("paper_wall_fence", new ItemStack(Blocks.FENCE_PAPER_WALL, 4));
+        fence.addInput('X', Items.INGOT_IRON).addInput('#', Items.CHAINLINK).create("chainlink_fence", new ItemStack(Blocks.FENCE_CHAINLINK, 8));
+    }
+
+    private static void generateFenceGates() {
+        RecipeBuilderShaped woodenFenceGate = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X#",
+                "#X#"
+            ).addInput('#', Items.STICK);
+
+        final int stackSize = 3;
+
+        for (DyeColor color : DyeColor.values()) {
+            woodenFenceGate.addInput('X', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_wooden_fence_gate", new ItemStack(Blocks.FENCE_GATE_PLANKS_OAK_PAINTED, stackSize, color.blockMeta << 4));
+        }
+        woodenFenceGate.addInput('X', Blocks.PLANKS_OAK).create("wooden_fence_gate", new ItemStack(Blocks.FENCE_GATE_PLANKS_OAK, stackSize));
+    }
+
+    private static void generateChests() {
+        RecipeBuilderShaped chest = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "X X",
+                "XXX"
+            );
+
+        for (DyeColor color : DyeColor.values()) {
+            chest.addInput('X', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_wooden_chest_from_planks", new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED, 1, color.blockMeta << 4));
+
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput("minecraft:chests").addInput(Items.DYE, color.itemMeta).create(color.colorID + "_wooden_chest_from_chest", new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED, 1, color.blockMeta << 4));
+        }
+        chest.addInput('X', Blocks.PLANKS_OAK).create("wooden_chest", Blocks.CHEST_PLANKS_OAK.getDefaultStack());
+    }
+
+    private static void generateLogToPlanks() {
+        final int stackSize = 4;
+        final String format = "%s_log_to_%s_wooden_planks";
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_OAK).create("oak_log_to_wooden_planks", new ItemStack(Blocks.PLANKS_OAK, stackSize));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_BIRCH).create(String.format(format, "birch", "white"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.WHITE.blockMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_CHERRY).create(String.format(format, "cherry", "pink"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.PINK.blockMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_EUCALYPTUS).create(String.format(format, "eucalyptus", "orange"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.ORANGE.blockMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_OAK_MOSSY).create(String.format(format, "mossy_oak", "green"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.GREEN.blockMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_PALM).create(String.format(format, "palm", "yellow"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.YELLOW.blockMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_THORN).create(String.format(format, "thorn", "red"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.RED.blockMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.LOG_PINE).create(String.format(format, "pine", "brown"), new ItemStack(Blocks.PLANKS_OAK_PAINTED, stackSize, DyeColor.BROWN.blockMeta));
+    }
+
+    private static void generateDyedWools() {
+        for (DyeColor color : DyeColor.values()) {
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput("minecraft:wools").addInput(Items.DYE, color.itemMeta).create(color.colorID + "_wool", new ItemStack(Blocks.WOOL, 1, color.blockMeta));
+        }
+    }
+
+    private static void generateDyedPlanks() {
+        RecipeBuilderShaped planks = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "XDX",
+                "XXX"
+            ).addInput('X', "minecraft:planks");
+        for (DyeColor color : DyeColor.values()) {
+            planks.addInput('D', Items.DYE, color.itemMeta).create(color.colorID + "_wooden_planks", new ItemStack(Blocks.PLANKS_OAK_PAINTED, 8, color.blockMeta));
+        }
+    }
+
+    private static void generatePolishedStones() {
+        RecipeBuilderShaped shape = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#",
+                "#");
+        final String format = "%1$s_to_polished_%1$s";
+        final int stackSize = 2;
+
+        shape.addInput('#', Blocks.STONE).create(String.format(format, "stone"), new ItemStack(Blocks.STONE_POLISHED, stackSize));
+        shape.addInput('#', Blocks.BASALT).create(String.format(format, "basalt"), new ItemStack(Blocks.BASALT_POLISHED, stackSize));
+        shape.addInput('#', Blocks.LIMESTONE).create(String.format(format, "limestone"), new ItemStack(Blocks.LIMESTONE_POLISHED, stackSize));
+        shape.addInput('#', Blocks.GRANITE).create(String.format(format, "granite"), new ItemStack(Blocks.GRANITE_POLISHED, stackSize));
+        shape.addInput('#', Blocks.SLATE).create(String.format(format, "slate"), new ItemStack(Blocks.SLATE_POLISHED, stackSize));
+        shape.addInput('#', Blocks.PERMAFROST).create(String.format(format, "permafrost"), new ItemStack(Blocks.PERMAFROST_POLISHED, stackSize));
+        shape.addInput('#', Blocks.NETHERRACK).create(String.format(format, "netherrack"), new ItemStack(Blocks.NETHERRACK_POLISHED, stackSize));
+    }
+
+    private static void generateInformationals() {
+        RecipeBuilderShaped info = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                " X ",
+                "X#X",
+                " X "
+            ).addInput('#', Items.DUST_REDSTONE);
+
+        info.addInput('X', "minecraft:planks").create("rotary_calendar", Items.TOOL_CALENDAR.getDefaultStack());
+        info.addInput('X', Items.INGOT_IRON).create("compass", Items.TOOL_COMPASS.getDefaultStack());
+        info.addInput('X', Items.INGOT_GOLD).create("clock", Items.TOOL_CLOCK.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "###",
+                "###",
+                "###")
+            .addInput('#', Items.PAPER)
+            .create("map", Items.MAP.getDefaultStack());
+
+    }
+
+    private static void generateFoods() {
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "# #",
+                " # ")
+            .addInput('#', "minecraft:planks")
+            .create("bowl", Items.BOWL.getDefaultStack());
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.BOWL).addInput(Blocks.MUSHROOM_BROWN).addInput(Blocks.MUSHROOM_RED).create("mushroom_stew", Items.FOOD_STEW_MUSHROOM.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("XXX")
+            .addInput('X', Items.WHEAT)
+            .create("bread", Items.FOOD_BREAD.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape("X#X")
+            .addInput('X', Items.WHEAT)
+            .addInput('#', new ItemStack(Items.DYE, 1, DyeColor.BROWN.itemMeta))
+            .create("cookie", new ItemStack(Items.FOOD_COOKIE, 16));
+
+        RecipeBuilderShaped cake = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "AAA",
+                "BEB",
+                "CCC")
+            .setConsumeContainer(false);
+
+        cake.addInput('A', Items.BUCKET_MILK)
+            .addInput('B', Items.DUST_SUGAR)
+            .addInput('E', Items.EGG_CHICKEN)
+            .addInput('C', Items.WHEAT)
+            .create("cake", Items.FOOD_CAKE.getDefaultStack());
+
+        cake.addInput('A', Items.BUCKET_MILK)
+            .addInput('B', Items.DUST_SUGAR)
+            .addInput('E', Blocks.PUMPKIN)
+            .addInput('C', Items.WHEAT)
+            .create("pumpkin_pie", Items.FOOD_PUMPKIN_PIE.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "X#X",
+                "XXX")
+            .addInput('X', Blocks.BLOCK_GOLD)
+            .addInput('#', Items.FOOD_APPLE)
+            .create("golden_apple", Items.FOOD_APPLE_GOLD.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                " Y ",
+                "#O#",
+                " X ")
+            .addInput('Y', Items.FOOD_CHERRY)
+            .addInput('O', new ItemStack(Items.DYE, 1, DyeColor.BROWN.itemMeta))
+            .addInput('#', Items.AMMO_SNOWBALL)
+            .addInput('X', Items.BUCKET)
+            .setConsumeContainer(true)
+            .create("ice_cream_bucket", Items.BUCKET_ICECREAM.getDefaultStack());
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.SUGARCANE).create("sugar_cane_to_sugar", new ItemStack(Items.DUST_SUGAR, 3));
+    }
+
+    private static void generateDyes() {
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Items.BONE).create("bone_to_dye", new ItemStack(Items.DYE, 3, DyeColor.WHITE.itemMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.RED.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.WHITE.itemMeta))
+            .create("red_dye_white_dye_to_pink_dye", new ItemStack(Items.DYE, 2, DyeColor.PINK.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.RED.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.YELLOW.itemMeta))
+            .create("red_dye_yellow_dye_to_orange_dye", new ItemStack(Items.DYE, 2, DyeColor.ORANGE.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.GREEN.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.WHITE.itemMeta))
+            .create("green_dye_white_dye_to_lime_dye", new ItemStack(Items.DYE, 2, DyeColor.LIME.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLACK.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.WHITE.itemMeta))
+            .create("black_dye_white_dye_to_gray_dye", new ItemStack(Items.DYE, 2, DyeColor.GRAY.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.GRAY.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.WHITE.itemMeta))
+            .create("gray_dye_white_dye_to_light_gray_dye", new ItemStack(Items.DYE, 2, DyeColor.SILVER.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.GRAY.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.GRAY.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLACK.itemMeta))
+            .create("black_dye_gray_dye_gray_dye_to_light_gray_dye", new ItemStack(Items.DYE, 3, DyeColor.SILVER.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLUE.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.WHITE.itemMeta))
+            .create("blue_dye_white_dye_to_light_blue_dye", new ItemStack(Items.DYE, 2, DyeColor.LIGHT_BLUE.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLUE.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.GREEN.itemMeta))
+            .create("blue_dye_green_dye_to_cyan_dye", new ItemStack(Items.DYE, 2, DyeColor.CYAN.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLUE.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.RED.itemMeta))
+            .create("blue_dye_red_dye_to_purple_dye", new ItemStack(Items.DYE, 2, DyeColor.PURPLE.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.PURPLE.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.PINK.itemMeta))
+            .create("purple_dye_pink_dye_to_magenta_dye", new ItemStack(Items.DYE, 2, DyeColor.MAGENTA.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLUE.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.RED.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.PINK.itemMeta))
+            .create("blue_dye_red_dye_pink_dye_to_magenta_dye", new ItemStack(Items.DYE, 3, DyeColor.MAGENTA.itemMeta));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.BLUE.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.RED.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.RED.itemMeta))
+            .addInput(new ItemStack(Items.DYE, 1, DyeColor.WHITE.itemMeta))
+            .create("blue_dye_red_dye_red_dye_white_dye_to_magenta_dye", new ItemStack(Items.DYE, 4, DyeColor.MAGENTA.itemMeta));
+
+
+        final int stackSize = 2;
+        final String formatFlower = "flower_%s_to_dye";
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.FLOWER_RED).create(String.format(formatFlower, "red"), new ItemStack(Items.DYE, stackSize, DyeColor.RED.itemMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.FLOWER_YELLOW).create(String.format(formatFlower, "yellow"), new ItemStack(Items.DYE, stackSize, DyeColor.YELLOW.itemMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.FLOWER_ORANGE).create(String.format(formatFlower, "orange"), new ItemStack(Items.DYE, stackSize, DyeColor.ORANGE.itemMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.FLOWER_PINK).create(String.format(formatFlower, "pink"), new ItemStack(Items.DYE, stackSize, DyeColor.PINK.itemMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.FLOWER_PURPLE).create(String.format(formatFlower, "purple"), new ItemStack(Items.DYE, stackSize, DyeColor.PURPLE.itemMeta));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.FLOWER_LIGHT_BLUE).create(String.format(formatFlower, "lightblue"), new ItemStack(Items.DYE, stackSize, DyeColor.LIGHT_BLUE.itemMeta));
+    }
+
+    private static void generateRedstoneComponents() {
+        RecipeBuilderShaped plate = RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("##");
+
+        plate.addInput('#', Blocks.STONE).create("stone_pressure_plate", Blocks.PRESSURE_PLATE_STONE.getDefaultStack());
+        plate.addInput('#', "minecraft:planks").create("wooden_pressure_plate", Blocks.PRESSURE_PLATE_PLANKS_OAK.getDefaultStack());
+        plate.addInput('#', "minecraft:cobblestones").create("cobblestone_pressure_plate", Blocks.PRESSURE_PLATE_COBBLE_STONE.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "XRX",
+                "XXX")
+            .addInput('X', "minecraft:planks")
+            .addInput('R', Items.DUST_REDSTONE)
+            .create("note_block", Blocks.NOTEBLOCK.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "#I#",
+                "#R#")
+            .addInput('X', "minecraft:planks")
+            .addInput('#', "minecraft:cobblestones")
+            .addInput('I', Items.INGOT_IRON)
+            .addInput('R', Items.DUST_REDSTONE)
+            .create("piston", new ItemStack(Blocks.PISTON_BASE));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "S",
+                "P")
+            .addInput('S', Items.SLIMEBALL)
+            .addInput('P', Blocks.PISTON_BASE)
+            .create("sticky_piston", Blocks.PISTON_BASE_STICKY.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X#X",
+                "#X#",
+                "X#X")
+            .addInput('X', Items.SULPHUR)
+            .addInput('#', Blocks.SAND)
+            .create("tnt", new ItemStack(Blocks.TNT));
+
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput("minecraft:stones").create("stone_button", new ItemStack(Blocks.BUTTON_STONE, 4));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "S",
+                "C")
+            .addInput('S', Items.STICK)
+            .addInput('C', "minecraft:cobblestones")
+            .create("cobblestone_lever", new ItemStack(Blocks.LEVER_COBBLE_STONE, 2));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "###",
+                "#O#",
+                "#X#")
+            .addInput('#', Blocks.GLASS)
+            .addInput('O', Items.QUARTZ)
+            .addInput('X', Items.DUST_REDSTONE)
+            .create("lamp", new ItemStack(Blocks.LAMP_IDLE, 4));
+
+        for (DyeColor color : DyeColor.values()) {
+            RecipeBuilder.Shapeless(CORE_NAMESPACE)
+                .addInput("minecraft:lamps")
+                .addInput(new ItemStack(Items.DYE, 1, color.itemMeta))
+                .create(color.colorID + "_lamp_convert", new ItemStack(Blocks.LAMP_IDLE, 1, color.blockMeta));
+        }
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X",
+                "#")
+            .addInput('X', Items.DUST_REDSTONE)
+            .addInput('#', Items.STICK)
+            .create("redstone_torch", new ItemStack(Blocks.TORCH_REDSTONE_ACTIVE, 1));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "#X#",
+                "III")
+            .addInput('#', Items.STICK)
+            .addInput('X', Items.DUST_REDSTONE)
+            .addInput('I', "minecraft:stones")
+            .create("redstone_repeater", new ItemStack(Items.REPEATER, 1));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X",
+                "#")
+            .addInput('X', Blocks.PUMPKIN_CARVED_IDLE)
+            .addInput('#', Blocks.TORCH_REDSTONE_ACTIVE)
+            .create("carved_pumpkin_to_redstone_jack_o_lantern", Blocks.PUMPKIN_REDSTONE.getDefaultStack());
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X X",
+                "X#X",
+                "X X")
+            .addInput('#', Items.STICK)
+            .addInput('X', Items.INGOT_IRON)
+            .create("rail", new ItemStack(Blocks.RAIL, 16));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X X",
+                "X#X",
+                "XRX")
+            .addInput('#', Items.STICK)
+            .addInput('X', Items.INGOT_GOLD)
+            .addInput('R', Items.DUST_REDSTONE)
+            .create("powered_rail", new ItemStack(Blocks.RAIL_POWERED, 8));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "X X",
+                "X#X",
+                "XRX")
+            .addInput('#', Blocks.PRESSURE_PLATE_STONE)
+            .addInput('X', Items.INGOT_IRON)
+            .addInput('R', Items.DUST_REDSTONE)
+            .create("detector_rail", new ItemStack(Blocks.RAIL_DETECTOR, 8));
+
+        RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                " # ",
+                "#X#",
+                "YYY")
+            .addInput('#', Items.INGOT_IRON)
+            .addInput('X', Items.DUST_REDSTONE)
+            .addInput('Y', "minecraft:cobblestones")
+            .create("spikes", new ItemStack(Blocks.SPIKES, 4));
+    }
+
+    private static void generateScrapRecipes() {
+        Registries.RECIPES.WORKBENCH.register("scrap_chainmail_boots",        new RecipeEntryScrap(Items.ARMOR_BOOTS_CHAINMAIL,       Items.CHAINLINK, 4));
+        Registries.RECIPES.WORKBENCH.register("scrap_chainmail_leggings",     new RecipeEntryScrap(Items.ARMOR_LEGGINGS_CHAINMAIL,    Items.CHAINLINK, 4));
+        Registries.RECIPES.WORKBENCH.register("scrap_chainmail_chestplate",   new RecipeEntryScrap(Items.ARMOR_CHESTPLATE_CHAINMAIL,  Items.CHAINLINK, 4));
+        Registries.RECIPES.WORKBENCH.register("scrap_chainmail_helmet",       new RecipeEntryScrap(Items.ARMOR_HELMET_CHAINMAIL,      Items.CHAINLINK, 4));
+    }
+
+    private static void generateRepairableRecipes() {
+         Registries.RECIPES.WORKBENCH.register("repair_chainmail_boots",       new RecipeEntryRepairable(Items.ARMOR_BOOTS_CHAINMAIL.getDefaultStack(),        new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+         Registries.RECIPES.WORKBENCH.register("repair_chainmail_leggings",    new RecipeEntryRepairable(Items.ARMOR_LEGGINGS_CHAINMAIL.getDefaultStack(),     new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+         Registries.RECIPES.WORKBENCH.register("repair_chainmail_chestplate",  new RecipeEntryRepairable(Items.ARMOR_CHESTPLATE_CHAINMAIL.getDefaultStack(),   new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+         Registries.RECIPES.WORKBENCH.register("repair_chainmail_helmet",      new RecipeEntryRepairable(Items.ARMOR_HELMET_CHAINMAIL.getDefaultStack(),       new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
+    }
+
+    private static void generateToolRecipes() {
+        Registries.RECIPES.WORKBENCH.register("carve_pumpkin_sword",     new RecipeEntryCraftingWithTool(new RecipeSymbol(Blocks.PUMPKIN.getDefaultStack()), new RecipeSymbol("minecraft:tool_swords"),     new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
+    }
+
+    private static void generateUndyeingRecipes() {
+        final String format = "%s_undyeing";
+        final int stackSize = 8;
+
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:planks"), new ItemStack(Blocks.PLANKS_OAK, stackSize)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "stairs_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:stairs_planks"), new ItemStack(Blocks.STAIRS_PLANKS_OAK, stackSize)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "slabs_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:slabs_planks"), new ItemStack(Blocks.SLAB_PLANKS_OAK, stackSize)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "fences_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:fences_planks"), new ItemStack(Blocks.FENCE_PLANKS_OAK, stackSize)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "fence_gates_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:fence_gates_planks"), new ItemStack(Blocks.FENCE_GATE_PLANKS_OAK, stackSize)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "trapdoor_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:trapdoor_planks"), new ItemStack(Blocks.TRAPDOOR_PLANKS_OAK, stackSize)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:lamps"), new ItemStack(Blocks.LAMP_IDLE, stackSize)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "wools"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:wools"), new ItemStack(Blocks.WOOL, stackSize)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "chests"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:chests"), new ItemStack(Blocks.CHEST_PLANKS_OAK, stackSize)));
+    }
+}
